
// #include <pthread.h>     /* pthread functions and data structures */
#include <iostream>
#define CERR std::cerr << __FILE__<<":"<<std::dec<<__LINE__<<": "
#include <string>
#include <map>
#include <list>

#include "cleanup.hpp"

struct Type1
{
protected:
	int m_c;
	static int counter;
public:

	Type1()
	{
		this->m_c = ++counter;
	}
	virtual ~Type1() { CERR << "~Type1#"<<this->m_c<<"()\n"; }

};

int Type1::counter = 0;

struct Type2 : public Type1
{
	Type2(){}
	virtual ~Type2() { CERR << "~Type2#"<<this->m_c<<"()\n"; }

};

// namespace clean {
// 	template <>
// 	struct cleanup_traits<Type1>;
// }


int main( int argc, char ** argv )
{

	typedef std::map<int,Type1 *> MapT;
	typedef std::list<MapT *> ListT;
	ListT li;
	for( int i = 0; i < 3; i++ )
	{
		MapT * m = new MapT;
		for( int it = 0; it < 4; it++ )
		{
			(*m)[it] = ( (it%2)==0) ? new Type1 : new Type2;
		}
		li.push_back( m );
	}

	CERR << "About to clean up. Watch for Type{1,2} dtors:\n";
	clean::cleanup( li );
	CERR << "^^^ Should see several dtors just before this line.\n";
        return 0;

}
